Function Alliances ()
	Local temp$, tcp, alliance_id, page, last_page

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Find how many alliances there are
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	;connect to game server
	Delay sleep : tcp = OpenTCPStream ("h728.serverid.net", 80)
	
	;alliance list (spoof Opera)
	WriteLine tcp, "GET /inselkampf/alliances HTTP/1.1"
	WriteLine tcp, "User-Agent: Opera/9.21 (Windows NT 5.0; U; en)"
	WriteLine tcp, "Host: h728.serverid.net"
	WriteLine tcp, "Accept: text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-bitmap, */*;q=0.1"
	WriteLine tcp, "Accept-Language: en-GB,en;q=0.9"
	WriteLine tcp, "Accept-Charset: iso-8859-1, utf-8, utf-16, *;q=0.1"
	WriteLine tcp, "Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0"
	WriteLine tcp, "Referer: h728.serverid.net/inselkampf/players"
	WriteLine tcp, "Cookie: _inselkampf="+cookie$
	WriteLine tcp, "Cookie2: $Version=1"
	WriteLine tcp, "Connection: Close, TE"
	WriteLine tcp, "TE: deflate, gzip, chunked, identity, trailers"
	WriteLine tcp, ""
	
	;DebugLog "GET /inselkampf/alliances HTTP/1.1"
	
	While Not Eof (tcp)
		temp$ = ReadLine (tcp)
		;get last page
		If Instr(temp$,"Last >>") Then
			temp$ = Left$(temp$, Len(temp$)-13)
			temp$ = Right$(temp$, Len(temp$)-Instr(temp$,"page=")-4)
			;DebugLog "Pages: "+temp$
			last_page = temp$
			Goto GotAllianceLastPage
		EndIf
	Wend
.GotAllianceLastPage	
	
	;disconnect
	CloseTCPStream tcp
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Get all player names
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;	Delay sleep : tcp = OpenTCPStream ("h728.serverid.net", 80)

	For page = 1 To last_page
	
		DebugLog "-------------------------------------------------------------"
		DebugLog "-------------------------------------------------------------"
		DebugLog "Alliance page "+page
		DebugLog "-------------------------------------------------------------"
		DebugLog "-------------------------------------------------------------"

.retryalliances

		;connect to game server
		Delay sleep : tcp = OpenTCPStream ("h728.serverid.net", 80)
		
		;check connection
		If Not tcp Then
			;wait 1 min and retry
			;DebugLog "TCP ERROR!"
			Delay 60000
			Goto retryalliances
		EndIf
		

		
		;rank list (spoof Opera)
		WriteLine tcp, "GET /inselkampf/alliances?page=" + Str$ (page) + " HTTP/1.1"
		WriteLine tcp, "User-Agent: Opera/9.21 (Windows NT 5.0; U; en)"
		WriteLine tcp, "Host: h728.serverid.net"
		WriteLine tcp, "Accept: text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-bitmap, */*;q=0.1"
		WriteLine tcp, "Accept-Language: en-GB,en;q=0.9"
		WriteLine tcp, "Accept-Charset: iso-8859-1, utf-8, utf-16, *;q=0.1"
		WriteLine tcp, "Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0"
		WriteLine tcp, "Referer: h728.serverid.net/inselkampf/players"
		WriteLine tcp, "Cookie: _inselkampf="+cookie$
		WriteLine tcp, "Cookie2: $Version=1"
		WriteLine tcp, "Connection: Close, TE"
		WriteLine tcp, "TE: deflate, gzip, chunked, identity, trailers"
		WriteLine tcp, ""
		
		;DebugLog "GET /inselkampf/alliances?page=" + Str$ (page) + " HTTP/1.1"
		
		;reset counter
		alliances_processed = 0
		
		While Not Eof (tcp)
		
			temp$ = ReadLine (tcp)
			DebugLog temp$
			
			;is ik down?
			If Instr(temp$,"We're sorry, but something went wrong.")
				;wait 1 min and retry
				;DebugLog "IK ERROR!"
				CloseTCPStream tcp				
				Delay 60000
;				Delay sleep : tcp = OpenTCPStream ("h728.serverid.net", 80)
				Goto retryalliances
			EndIf
			
			;is ik down?
			If Instr(temp$,"<h2>Application error</h2>")
				;wait 1 min and retry
				;DebugLog "IK ERROR!"
				Delay 60000
				CloseTCPStream tcp
				Goto retryalliances
			EndIf
		
			;line contains player data
			If Instr (temp$, "/inselkampf/alliances/show/")
		
				;crop left
				temp$ = Right (temp$, Len (temp$) - Instr (temp$, "/inselkampf/alliances/show/") - 26)
			
				;crop right
				alliance_id = Left (temp$, Instr (temp$, Chr$(34) + ">") - 1)
				
				;save player
				;DebugLog "Alliance: "+alliance_id
				
				a.alliance = New alliance
				a\id = alliance_id
				
				;increment counter
				alliances_processed = alliances_processed + 1
				
			EndIf
			
			If Instr(temp$,"</html>") Then Goto EndPage
		Wend
.EndPage		
	
		;disconnect
		CloseTCPStream tcp
	
		;no new alliances, error so decrement and retry
		If alliances_processed = 0 Then page = page - 1
	
	Next 
	
;	CloseTCPStream tcp
				
End Function