Function Alliancestats ()
	Local temp$, tcp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Loop through all known alliances and get more stats
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	;loop through all players
	For a.alliance = Each alliance

.retryalliancestats

		;connect to game server
		Delay sleep : tcp = OpenTCPStream ("h728.serverid.net", 80)
		
		;check connection
		If Not tcp Then
			;wait 1 min and retry
			;DebugLog "TCP ERROR!"
			Delay 60000
			Goto retryalliancestats
		EndIf
		
		;alliance page (spoof Opera)
		WriteLine tcp, "GET /inselkampf/alliances/show/" + a\id + " HTTP/1.1"
		WriteLine tcp, "User-Agent: Opera/9.21 (Windows NT 5.0; U; en)"
		WriteLine tcp, "Host: h728.serverid.net"
		WriteLine tcp, "Accept: text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-bitmap, */*;q=0.1"
		WriteLine tcp, "Accept-Language: en-GB,en;q=0.9"
		WriteLine tcp, "Accept-Charset: iso-8859-1, utf-8, utf-16, *;q=0.1"
		WriteLine tcp, "Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0"
		WriteLine tcp, "Referer: h728.serverid.net/inselkampf/players"
		WriteLine tcp, "Cookie: _inselkampf="+cookie$
		WriteLine tcp, "Cookie2: $Version=1"
		WriteLine tcp, "Connection: Close, TE"
		WriteLine tcp, "TE: deflate, gzip, chunked, identity, trailers"
		WriteLine tcp, ""
		
		;DebugLog "GET /inselkampf/alliances/show/" + a\id + " HTTP/1.1"
		DebugLog "-------------------------------------------------------------"
		DebugLog "-------------------------------------------------------------"
		DebugLog "Alliance Stats for "+a\id
		DebugLog "-------------------------------------------------------------"
		DebugLog "-------------------------------------------------------------"
		
		While Not Eof (tcp)
			temp$ = ReadLine (tcp)
			DebugLog temp$

			;is ik down?
			If Instr(temp$,"We're sorry, but something went wrong.")
				;wait 1 min and retry
				;DebugLog "IK ERROR!"
				Delay 60000
				CloseTCPStream tcp
				Goto retryalliancestats
			EndIf	
			
			;is ik down?
			If Instr(temp$,"<h2>Application error</h2>")
				;wait 1 min and retry
				;DebugLog "IK ERROR!"
				Delay 60000
				CloseTCPStream tcp
				Goto retryalliancestats
			EndIf
					
			
			;tag
			If Instr(temp$,"<tr><td width="+Chr$(34)+"50%"+Chr$(34)+"><b>Tag</b></td><td>") Then
				;crop to find tag
				temp$ = Right$(temp$,Len(temp$)-39)
				temp$ = Left$(temp$,Len(temp$)-10)
				a\tag$ = temp$
						
			;score
			ElseIf Instr(temp$,"<tr><td><b>Score</b></td><td>") Then
				;crop to find score
				temp$ = Right$(temp$,Len(temp$)-29)
				temp$ = Left$(temp$,Len(temp$)-10)
				a\score = temp$
			
			;rank
			ElseIf Instr(temp$,"<tr><td><b>Rank</b></td><td>") Then
				;crop to find rank
				temp$ = Right$(temp$,Len(temp$)-28)
				temp$ = Left$(temp$,Len(temp$)-10)
				a\rank = temp$

			;members
			ElseIf Instr(temp$,"<tr><td><b>Members</b></td><td>") Then
				;crop to find members
				temp$ = Right$(temp$,Len(temp$)-31)
				temp$ = Left$(temp$,Len(temp$)-10)
				a\members = temp$
								
				Goto GotAllianceStats

				
			EndIf
		Wend

.GotAllianceStats

		;EPIC FAIL
		If a\rank = 0 Then Goto retryalliancestats
	
		;DebugLog "Alliance tag: "+a\name$
		;DebugLog "score: "+a\score
		;DebugLog "rank: "+a\rank
		;DebugLog "members: "+a\members
	
		;disconnect
		CloseTCPStream tcp
	
	Next
				
End Function